# -*- coding: utf-8 -*-
"""
Created on Tue Apr 15 10:52:10 2014

@author: ben
"""

from pylab import *
from numpy import *
from PIL import Image
import cv2
from matplotlib import pyplot as PLT
import StringIO
import PIL
import functions

# If you have PCV installed, these imports should work
from PCV.geometry import homography, camera
#from PCV.localdescriptors import sift
from PCV.localdescriptors import sift

"""
This is the augmented reality and pose estimation cube example from Section 4.3.
"""



mysift = cv2.SIFT(400)

img0 = cv2.imread('Images/imageTest1.1.jpg',cv2.COLOR_BGR2GRAY)
#print img0
l0, d0 = mysift.detectAndCompute(img0,None)
l0=np.asarray([ [i.pt[0],i.pt[1]] for i in l0]) #convert to array([[x0,y0],[x1,y1],...])

img1 = cv2.imread('Images/imageTest1.2.jpg',cv2.COLOR_BGR2GRAY)
l1, d1 = mysift.detectAndCompute(img1,None)
l1=np.asarray([ [i.pt[0],i.pt[1]] for i in l1]) #convert to array([[x0,y0],[x1,y1],...])


#match features and estimate homography
matches = sift.match_twosided(d0,d1)
ndx = matches.nonzero()[0]
fp = homography.make_homog(l0[ndx,:2].T) 
ndx2 = [int(matches[i]) for i in ndx]
tp = homography.make_homog(l1[ndx2,:2].T)

model = homography.RansacModel()
H, inliers = homography.H_from_ransac(fp,tp,model) 
# camera calibration
K = functions.my_calibration((747,1000))

# 3D points at plane z=0 with sides of length 0.2
box = functions.cube_points([0,0,0.1],0.1)

# project bottom square in first image
cam1 = camera.Camera( hstack((K,dot(K,array([[0],[0],[-1]])) )) )
# first points are the bottom square
box_cam1 = cam1.project(homography.make_homog(box[:,:5])) 


# use H to transfer points to the second image
box_trans = homography.normalize(dot(H,box_cam1))

# compute second camera matrix from cam1 and H
cam2 = camera.Camera(dot(H,cam1.P))
A = dot(linalg.inv(K),cam2.P[:,:3])
A = array([A[:,0],A[:,1],cross(A[:,0],A[:,1])]).T 
cam2.P[:,:3] = dot(K,A)

# project with the second camera
box_cam2 = cam2.project(homography.make_homog(box))



# plotting
im0 = array(img0)
im1 = array(img1)

print H

figure()
imshow(im0)
plot(box_cam1[0,:],box_cam1[1,:],linewidth=3)
title('2D projection of bottom square')
axis('off')
#savefig("2Dprojection.jpg")

figure()
imshow(im1)
plot(box_trans[0,:],box_trans[1,:],linewidth=3)
title('2D projection transfered with H')
axis('off')
#savefig("2Dprojectiontranslate.jpg")


figure()
imshow(im1)
plot(box_cam2[0,:],box_cam2[1,:],linewidth=3)
title('3D points projected in second image')
axis('off')
#savefig("3Dprojection.jpg")

show()